package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.strike;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.api.server.HttpServer;
import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.Teams;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.VaroTeam;

import java.util.List;
import java.util.Objects;
import java.util.UUID;
import java.util.stream.Collectors;

public class Strike extends Appliance {
    @Override
    public void httpApi(HttpServer.ApiBuilder apiBuilder) {
        record StrikeInfo(List<UUID> users, int totalWeight) {
        }
        apiBuilder.post("update", StrikeInfo.class, (data, request) -> {
            Main.instance().getLogger().info(String.format(
                "API Triggered Strike-Profile update for %s",
                data.users.stream().map(UUID::toString).collect(Collectors.joining(", ")))
            );

            VaroTeam team = null;
            for(UUID uuid : data.users) {
                team = this.queryAppliance(Teams.class).getTeamFromPlayer(uuid);
                if(team != null) break;
            }
            Objects.requireNonNull(team);

            System.out.println(team.name);

            return HttpServer.nothing;
        });
    }
}
